## ktechlab 0.50.0

=== CMakeLists.txt ===
# cmake CXX_STANDARD needs min cmake 3.1
# https://stackoverflow.com/questions/10984442/how-to-detect-c11-support-of-a-compiler-with-cmake/20165220#20165220
cmake_minimum_required(VERSION 3.1)

#set( KTECHLAB_DEVELOPER_BUILD "true" )

project( ktechlab )
set( VERSION 0.50.0 )

# set(CMAKE_DEBUG_TARGET_PROPERTIES INCLUDE_DIRECTORIES)

find_package(ECM 0.0.11 CONFIG REQUIRED)
set(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake/modules ${ECM_MODULE_PATH})

include(KDEInstallDirs)
include(KDECMakeSettings)
include(KDECompilerSettings NO_POLICY_SCOPE)

include(ECMInstallIcons)
include(FeatureSummary)

if(BUILD_TESTING)
    set(QT_ADDITIONAL_COMPONENTS Test)
endif()
find_package(Qt5 CONFIG REQUIRED COMPONENTS
    Core
    DBus
    Widgets
    PrintSupport
    ${QT_ADDITIONAL_COMPONENTS}
    )

find_package(KF5 REQUIRED COMPONENTS
    Config
    CoreAddons
    DocTools
    IconThemes
    I18n
    KHtml
    KIO
    Parts
    TextEditor
    TextWidgets
    Solid
    WidgetsAddons
    WindowSystem
    XmlGui
    )

# Edit FindGPSim and replace
#    include(MacroPushRequiredVars) -> include(CMakePushCheckState)
#    macro_push_required_vars() -> cmake_push_check_state()
#    macro_pop_required_vars() -> cmake_pop_check_state()
find_package(GPSim)

add_definitions(-Wno-deprecated-declarations) # TODO too much spam for now
add_definitions(-fPIC)
add_definitions(
    -DQT_DISABLE_DEPRECATED_BEFORE=0 # even 0x050000 would be too high for now
    -DQT_DEPRECATED_WARNINGS_SINCE=0x060000 # to enable warnings for API since the disabled limit
#     -DQT_USE_QSTRINGBUILDER # TODO
#     -DQT_NO_CAST_TO_ASCII # TODO
#     -DQT_NO_CAST_FROM_ASCII # TODO
#     -DQT_NO_CAST_FROM_BYTEARRAY # TODO
#     -DQT_STRICT_ITERATORS # TODO
    -DQT_NO_URL_CAST_FROM_STRING
#     -DQT_NO_KEYWORDS # TODO
    -DQT_NO_NARROWING_CONVERSIONS_IN_CONNECT
#    -DQT_NO_FOREACH # needed by KConfig system at least on Ubuntu 18.04
    -DKF_DISABLE_DEPRECATED_BEFORE_AND_AT=0x050000
    -DKF_DEPRECATED_WARNINGS_SINCE=0x060000 # to enable warnings for API since the disabled limit
)

#set(CMAKE_VERBOSE_MAKEFILE ON)

if (KTECHLAB_DEVELOPER_BUILD)
# for debugging with GCC 5
    add_definitions( -fno-omit-frame-pointer )
    set(SANITIZE_FLAGS " -fsanitize=address -fno-omit-frame-pointer -fPIC") # address
    #set(SANITIZE_FLAGS " -fsanitize=undefined -fno-omit-frame-pointer ") # undefined
    #set(SANITIZE_FLAGS "") # disabled

    #add_definitions ( -DQT3_SUPPORT_WARNINGS )

    add_definitions( ${SANITIZE_FLAGS} )
    SET( CMAKE_EXE_LINKER_FLAGS  "${CMAKE_EXE_LINKER_FLAGS} ${SANITIZE_FLAGS}" )

    #add_definitions( -Wold-style-cast ) # warn on old style casts. as these could introduce bugs

endif (KTECHLAB_DEVELOPER_BUILD)

add_definitions( -fno-inline )  # do not inline any method calls; this is useful for crash debugging
add_definitions(
    ${Qt5Core_EXECUTABLE_COMPILE_FLAGS}
    ${GLIB2_DEFINITIONS}
)

message("Qt5Core_EXECUTABLE_COMPILE_FLAGS=>>>${Qt5Core_EXECUTABLE_COMPILE_FLAGS}<<<" )


# KDE disables STL compatibility by default; re-enabling it is supported
# see http://kde.6490.n7.nabble.com/QT-NO-STL-in-KDE4-td1123882i20.html
# and http://www.cmake.org/Wiki/HowToBuildKDE4Software#Some_useful_functions
remove_definitions(-DQT_NO_STL)

# TODO switch to NO_GPSIM to HAVE_GPSIM
if (NOT GPSim_FOUND)
    set(NO_GPSIM TRUE)
endif ()

include_directories(
    # for config.h file
    ${CMAKE_CURRENT_BINARY_DIR}
)

set( SRC_EXAMPLES_DIR ${CMAKE_CURRENT_SOURCE_DIR}/examples/ )
set( SRC_TESTS_DATA_DIR ${CMAKE_CURRENT_SOURCE_DIR}/tests/data/ )

CONFIGURE_FILE( ${CMAKE_SOURCE_DIR}/config.h.cmake
	${CMAKE_BINARY_DIR}/config.h )


# message(STATUS "include_dir begin")
# get_property(dirs DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR} PROPERTY INCLUDE_DIRECTORIES)
# foreach(dir ${dirs})
#   message(STATUS "include_dir='${dir}'")
# endforeach()
# message(STATUS "include_dir end")

# message(STATUS "variables begin")
# get_cmake_property(_variableNames VARIABLES)
# list (SORT _variableNames)
# foreach (_variableName ${_variableNames})
#     message(STATUS "${_variableName}=${${_variableName}}")
# endforeach()
# message(STATUS "variables end")

add_subdirectory( microbe )
add_subdirectory( src )
add_subdirectory( examples )
add_subdirectory( icons )
add_subdirectory( icons-kde3 )
add_subdirectory( doc )

if(BUILD_TESTING)
    add_subdirectory(tests)
endif()

feature_summary(WHAT ALL FATAL_ON_MISSING_REQUIRED_PACKAGES)

find_package(KF5I18n CONFIG REQUIRED)
ki18n_install(po)

  find_package(KF5DocTools CONFIG)
  if(KF5DocTools_FOUND)
    kdoctools_install(po)
  endif()

=== icons-kde3/CMakeLists.txt ===
install( FILES
    Crystal/22x22/actions/attach.png
    Crystal/48x48/filesystems/blockdevice.png
    Crystal/48x48/filesystems/exec.png
    Crystal/48x48/mimetypes/source.png

    nuvola/32x32/actions/pencil.png

    DESTINATION ${DATA_INSTALL_DIR}/ktechlab/pics
    )

=== icons/CMakeLists.txt ===
add_subdirectory(pics)

########### install files ###############

file(GLOB icons_apps "${CMAKE_CURRENT_SOURCE_DIR}/*-apps-*.png")
file(GLOB icons_mimetypes "${CMAKE_CURRENT_SOURCE_DIR}/*-mimetypes-*.png")
ecm_install_icons(ICONS ${icons_apps} ${icons_mimetypes} DESTINATION ${ICON_INSTALL_DIR})

=== microbe/CMakeLists.txt ===
SET(microbe_SRCS
   btreebase.cpp
   btreenode.cpp
   main.cpp
   traverser.cpp
   expression.cpp
   pic14.cpp
   variable.cpp
   optimizer.cpp
   instruction.cpp
   microbe.cpp
   parser.cpp
)

add_executable(microbe ${microbe_SRCS})

target_link_libraries(microbe
    KF5::CoreAddons
    KF5::I18n

    Qt5::Core

    pthread)

install(TARGETS microbe ${INSTALL_TARGETS_DEFAULT_ARGS})

=== src/CMakeLists.txt ===
include_directories(
    ${CMAKE_CURRENT_SOURCE_DIR}  # needed for subdirs
    ${CMAKE_CURRENT_SOURCE_DIR}/core
    ${CMAKE_CURRENT_BINARY_DIR}/core  # for the kcfg file
    ${CMAKE_CURRENT_SOURCE_DIR}/drawparts
    ${CMAKE_CURRENT_SOURCE_DIR}/electronics
    ${CMAKE_CURRENT_SOURCE_DIR}/electronics/components
    ${CMAKE_CURRENT_SOURCE_DIR}/electronics/simulation
    ${CMAKE_CURRENT_SOURCE_DIR}/flowparts
    ${CMAKE_CURRENT_SOURCE_DIR}/gui
    ${CMAKE_CURRENT_BINARY_DIR}/gui  # for ui-generated files
    ${CMAKE_CURRENT_SOURCE_DIR}/gui/itemeditor
    ${CMAKE_CURRENT_SOURCE_DIR}/languages
    ${CMAKE_CURRENT_SOURCE_DIR}/mechanics
    ${CMAKE_CURRENT_SOURCE_DIR}/micro
    ${CMAKE_CURRENT_SOURCE_DIR}/ktlqt3support
)
if(GPSim_FOUND)
    # mark SYSTEM to have the compiler not emit warnings for those headers
    include_directories(SYSTEM ${GPSim_INCLUDE_DIRS})
    kde_enable_exceptions()
endif()

add_subdirectory(core)
add_subdirectory(gui)
add_subdirectory(flowparts)
add_subdirectory(micro)
add_subdirectory(mechanics)
add_subdirectory(electronics)
add_subdirectory(languages)
add_subdirectory(drawparts)
add_subdirectory(contexthelp)
add_subdirectory(math)
add_subdirectory(ktlqt3support)

########### next target ###############

set(core_KCFG_SRCS
    core/ktlconfig.kcfgc
)
kconfig_add_kcfg_files(core_STAT_SRCS ${core_KCFG_SRCS})

set(gui_UI
    ./gui/gpasmsettingswidget.ui
    ./gui/newpinmappingwidget.ui
    ./gui/outputmethodwidget.ui
    ./gui/logicwidget.ui
    ./gui/microsettingswidget.ui
    ./gui/createsubprojectwidget.ui
    ./gui/picprogrammerconfigwidget.ui
    ./gui/contexthelpwidget.ui
    ./gui/linkeroptionswidget.ui
    ./gui/programmerwidget.ui
    ./gui/newprojectwidget.ui
    ./gui/scopescreenwidget.ui
    ./gui/oscilloscopewidget.ui
    ./gui/newfilewidget.ui
    ./gui/processingoptionswidget.ui
    ./gui/asmformattingwidget.ui
    ./gui/generaloptionswidget.ui
    ./gui/sdccoptionswidget.ui
    ./gui/gplinksettingswidget.ui
)

ki18n_wrap_ui(gui_STAT_SRCS ${gui_UI})

SET(ktechlab_SRCS
    ${core_STAT_SRCS}
    ${gui_STAT_SRCS}
    ./document.cpp
    ./gui/programmerdlg.cpp
    ./gui/itemeditor/propertyeditoritem.cpp
    ./gui/itemeditor/itemeditor.cpp
    ./gui/itemeditor/propertyeditor.cpp
    ./gui/itemeditor/propertysubeditor.cpp
    ./gui/itemeditor/componentmodelwidget.cpp
    ./gui/itemeditor/propertyeditorlist.cpp
    ./gui/itemeditor/propertyeditorcolor.cpp
    ./gui/itemeditor/orientationwidget.cpp
    ./gui/itemeditor/propertyeditorinput.cpp
    ./gui/itemeditor/propertyeditorfile.cpp
    ./gui/probepositioner.cpp
    ./gui/richtexteditor.cpp
    ./gui/logview.cpp
    ./gui/contexthelp.cpp
    ./gui/oscilloscopeview.cpp
    ./gui/doublespinbox.cpp
    ./gui/lineedit.cpp
    ./gui/inputdialog.cpp
    ./gui/microselectwidget.cpp
    ./gui/scopescreen.cpp
    ./gui/itemselector.cpp
    ./gui/scopescreenview.cpp
    ./gui/microsettingsdlg.cpp
    ./gui/colorcombo.cpp
    ./gui/symbolviewer.cpp
    ./gui/oscilloscope.cpp
    ./gui/newfiledlg.cpp
    ./gui/projectdlgs.cpp
    ./gui/outputmethoddlg.cpp
    ./gui/scopeviewbase.cpp
    ./gui/settingsdlg.cpp
    ./gui/imageexportdlg.cpp
    ./projectmanager.cpp
    ./cells.cpp
    ./docmanageriface.cpp
    ./micro/picinfo16bit.cpp
    ./micro/picinfo12bit.cpp
    ./micro/picinfo.cpp
    ./micro/micropackage.cpp
    ./micro/microlibrary.cpp
    ./micro/picinfo14bit.cpp
    ./micro/microinfo.cpp
    ./micro/asminfo.cpp
    ./ciwidgetmgr.cpp
    ./fpnode.cpp
    ./textdocument.cpp
    ./filemetainfo.cpp
    ./resizeoverlay.cpp
    ./viewcontainer.cpp
    ./microsettings.cpp
    ./nodegroup.cpp
    ./flowcodeview.cpp
    ./debugmanager.cpp
    ./flowparts/readport.cpp
    ./flowparts/inputflownode.cpp
    ./flowparts/repeat.cpp
    ./flowparts/embed.cpp
    ./flowparts/sub.cpp
    ./flowparts/while.cpp
    ./flowparts/flowconnectorlist.cpp
    ./flowparts/setpin.cpp
    ./flowparts/pinmapping.cpp
    ./flowparts/interrupt.cpp
    ./flowparts/inputbutton.cpp
    ./flowparts/flowicndocument.cpp
    ./flowparts/testpin.cpp
    ./flowparts/flowconnector.cpp
    ./flowparts/writeport.cpp
    ./flowparts/flowpart.cpp
    ./flowparts/forloop.cpp
    ./flowparts/count.cpp
    ./flowparts/outputflownode.cpp
    ./flowparts/end.cpp
    ./flowparts/callsub.cpp
    ./flowparts/unary.cpp
    ./flowparts/start.cpp
    ./flowparts/varassignment.cpp
    ./flowparts/delay.cpp
    ./flowparts/pulse.cpp
    ./flowparts/junctionflownode.cpp
    ./flowparts/keypad.cpp
    ./flowparts/sevenseg.cpp
    ./flowparts/varcomparison.cpp
    ./math/qvector.cpp
    ./math/qmatrix.cpp
    ./picitem.cpp
#     ./core/main.cpp
    ./core/diagnosticstyle.cpp
    ./core/logtofilemsghandler.cpp
    ./node.cpp
    ./documentiface.cpp
    ./docmanager.cpp
    ./itemview.cpp
    ./viewiface.cpp
    ./icndocument.cpp
    ./itemdocument.cpp
    ./itemgroup.cpp
    ./cnitemgroup.cpp
    ./canvasmanipulator.cpp
    ./iteminterface.cpp
    ./mechanics/mechanicsitem.cpp
    ./mechanics/mechanicsdocument.cpp
    ./mechanics/chassiscircular2.cpp
    ./mechanics/mechanicssimulation.cpp
    ./mechanics/mechanicsview.cpp
    ./mechanics/mechanicsgroup.cpp
    ./electronics/electronicconnector.cpp
    ./electronics/circuitdocument.cpp
    ./electronics/ecnode.cpp
#     ./electronics/models/utils/spice-to-nice.cpp
    ./electronics/pinnode.cpp
    ./electronics/port.cpp
    ./electronics/components/variablecapacitor.cpp
    ./electronics/components/rotoswitch.cpp
    ./electronics/components/led.cpp
    ./electronics/components/binarycounter.cpp
    ./electronics/components/probe.cpp
    ./electronics/components/inductor.cpp
    ./electronics/components/eccurrentsignal.cpp
    ./electronics/components/ecpotentiometer.cpp
    ./electronics/components/flipflop.cpp
    ./electronics/components/serialportcomponent.cpp
    ./electronics/components/piccomponentpin.cpp
    ./electronics/components/ecopamp.cpp
    ./electronics/components/multiplexer.cpp
    ./electronics/components/ecmosfet.cpp
    ./electronics/components/dependentsource.cpp
    ./electronics/components/ecground.cpp
    ./electronics/components/resistordip.cpp
    ./electronics/components/magnitudecomparator.cpp
    ./electronics/components/piccomponent.cpp
    ./electronics/components/matrixdisplay.cpp
    ./electronics/components/eccurrentsource.cpp
    ./electronics/components/ecvoltagesignal.cpp
    ./electronics/components/demultiplexer.cpp
    ./electronics/components/externalconnection.cpp
    ./electronics/components/ledbargraphdisplay.cpp
    ./electronics/components/bidirled.cpp
    ./electronics/components/ecbcdto7segment.cpp
    ./electronics/components/ecsevensegment.cpp
    ./electronics/components/ecvoltagesource.cpp
    ./electronics/components/parallelportcomponent.cpp
    ./electronics/components/ec555.cpp
    ./electronics/components/resistor.cpp
    ./electronics/components/voltageregulator.cpp
    ./electronics/components/multiinputgate.cpp
    ./electronics/components/discretelogic.cpp
    ./electronics/components/pushswitch.cpp
    ./electronics/components/ecjfet.cpp
    ./electronics/components/meter.cpp
    ./electronics/components/variableresistor.cpp
    ./electronics/components/ecsignallamp.cpp
    ./electronics/components/ecclockinput.cpp
    ./electronics/components/ecbjt.cpp
    ./electronics/components/matrixdisplaydriver.cpp
    ./electronics/components/fulladder.cpp
    ./electronics/components/ecdiode.cpp
    ./electronics/components/ecfixedvoltage.cpp
    ./electronics/components/bussplitter.cpp
    ./electronics/components/capacitor.cpp
    ./electronics/components/ram.cpp
    ./electronics/components/toggleswitch.cpp
    ./electronics/components/ecsubcircuit.cpp
    ./electronics/components/addac.cpp
    ./electronics/components/eckeypad.cpp
    ./electronics/junctionnode.cpp
    ./electronics/switch.cpp
    ./electronics/gpsimprocessor.cpp
    ./electronics/wire.cpp
    ./electronics/componentmodellibrary.cpp
    ./electronics/pin.cpp
    ./electronics/circuiticndocument.cpp
    ./electronics/simulation/circuit.cpp
    ./electronics/simulation/element.cpp
    ./electronics/simulation/matrix.cpp
    ./electronics/simulation/diode.cpp
    ./electronics/simulation/elementsignal.cpp
    ./electronics/simulation/voltagesignal.cpp
    ./electronics/simulation/capacitance.cpp
    ./electronics/simulation/resistance.cpp
    ./electronics/simulation/elementset.cpp
    ./electronics/simulation/inductance.cpp
    ./electronics/simulation/voltagesource.cpp
    ./electronics/simulation/voltagepoint.cpp
    ./electronics/simulation/vcvs.cpp
    ./electronics/simulation/mosfet.cpp
    ./electronics/simulation/jfet.cpp
    ./electronics/simulation/ccvs.cpp
    ./electronics/simulation/bjt.cpp
    ./electronics/simulation/opamp.cpp
    ./electronics/simulation/currentsource.cpp
    ./electronics/simulation/cccs.cpp
    ./electronics/simulation/vccs.cpp
    ./electronics/simulation/logic.cpp
    ./electronics/simulation/nonlinear.cpp
    ./electronics/simulation/currentsignal.cpp
    ./electronics/simulation/reactive.cpp
    ./electronics/subcircuits.cpp
    ./electronics/component.cpp
    ./circuitview.cpp
    ./itemlibrary.cpp
    ./simulator.cpp
    ./dcop_stub.cpp
    ./variablelabel.cpp
    ./item.cpp
    ./itemdocumentdata.cpp
    ./ktlqt3support/ktlfindqobjectchild.cpp
    ./ktlqt3support/ktlq3scrollview.cpp
    ./ktlqt3support/ktlq3polygonscanner.cpp
    ./ktlqt3support/ktlq3frame.cpp
    ./oscilloscopedata.cpp
    ./variant.cpp
    ./connector.cpp
    ./icnview.cpp
    ./drawparts/drawpart.cpp
    ./drawparts/dpline.cpp
    ./drawparts/solidshape.cpp
    ./drawparts/dptext.cpp
    ./drawparts/dpimage.cpp
    ./textview.cpp
    ./katemdi.cpp
    ./view.cpp
    ./ktechlab.cpp
    ./canvasitemparts.cpp
    ./eventinfo.cpp
    ./canvasitemlist.cpp
    ./asmformatter.cpp
    ./cnitem.cpp
    ./flowcodedocument.cpp
    ./libraryitem.cpp
    ./conrouter.cpp
    ./recentfilesaction.cpp
    ./canvas.cpp
    ./canvasitems.cpp
    ./flowcontainer.cpp
    ./languages/processchain.cpp
    ./languages/gpdasm.cpp
    ./languages/gplink.cpp
    ./languages/gplib.cpp
    ./languages/language.cpp
    ./languages/sourceline.cpp
    ./languages/microbe.cpp
    ./languages/picprogrammer.cpp
    ./languages/externallanguage.cpp
    ./languages/asmparser.cpp
    ./languages/languagemanager.cpp
    ./languages/gpasm.cpp
    ./languages/sdcc.cpp
    ./languages/flowcode.cpp
)

set(ktechlab_DCOP_SKEL_SRCS
    docmanageriface.h
    viewiface.h
    documentiface.h
)

#kde3_add_dcop_skels(ktechlab_SRCS ${ktechlab_DCOP_SKEL_SRCS})

add_executable(ktechlab
    core/main.cpp
    ${ktechlab_SRCS}
    )

target_link_libraries( ktechlab
    #core 
#     gui 
    #micro 
    #flowparts
    #ktlqt3support
	#mechanics electronics elements components languages drawparts
	#itemeditor math
    KF5::TextEditor
    KF5::Parts
    KF5::ConfigCore
    KF5::ConfigGui
    KF5::CoreAddons
    KF5::IconThemes
    KF5::KIOCore
    KF5::KHtml
    KF5::XmlGui
    KF5::WidgetsAddons
    KF5::WindowSystem

    Qt5::Widgets
    Qt5::PrintSupport
)
if(GPSim_FOUND)
    target_link_libraries(ktechlab ${GPSim_LIBRARIES})
endif()

install(TARGETS ktechlab ${INSTALL_TARGETS_DEFAULT_ARGS})


# message(STATUS "include_dir begin")
# get_property(dirs TARGET ktechlab PROPERTY INCLUDE_DIRECTORIES)
# foreach(dir ${dirs})
#   message(STATUS "ktechlab include_dir='${dir}'")
# endforeach()
# message(STATUS "include_dir end")

# message(STATUS "include_dir begin")
# get_property(dirs TARGET KF5::TextEditor PROPERTY INTERFACE_INCLUDE_DIRECTORIES)
# foreach(dir ${dirs})
#   message(STATUS "KF5::TextEditor include_dir='${dir}'")
# endforeach()
# message(STATUS "include_dir end")

# for helping testing

add_library(test_ktechlab STATIC ${ktechlab_SRCS})

target_link_libraries(test_ktechlab
    KF5::TextEditor
    KF5::IconThemes
    KF5::Parts
    KF5::KHtml
    KF5::WidgetsAddons
    KF5::WindowSystem

    Qt5::Widgets
    Qt5::PrintSupport
)

=== doc/en/CMakeLists.txt ===
kdoctools_create_handbook(index.docbook INSTALL_DESTINATION ${KDE_INSTALL_DOCBUNDLEDIR}/en SUBDIR ktechlab)

=== examples/555/CMakeLists.txt ===
install(FILES
	internals.circuit
	square-wave.circuit
	DESTINATION ${DATA_INSTALL_DIR}/ktechlab/examples/555)

=== examples/basic/CMakeLists.txt ===
install(FILES  
	2-way-switch.circuit
	3-way-switch.circuit
	capacitor.circuit
	lrc.circuit resistors-parallel.circuit
	resistors-series.circuit
	voltage-divider.circuit
	DESTINATION ${DATA_INSTALL_DIR}/ktechlab/examples/basic)

=== examples/diodes/CMakeLists.txt ===
install(FILES
	full-wave-rectifier.circuit
	half-wave-rectifier.circuit
	DESTINATION ${DATA_INSTALL_DIR}/ktechlab/examples/diodes)

=== examples/jfets/CMakeLists.txt ===
install(FILES
	inverter.circuit
	DESTINATION ${DATA_INSTALL_DIR}/ktechlab/examples/jfets)

=== examples/matrix_disp_driver/CMakeLists.txt ===
install(FILES
	matrix_display.circuit
	DESTINATION ${DATA_INSTALL_DIR}/ktechlab/examples/matrix_disp_driver)

=== examples/opamps/CMakeLists.txt ===
install(FILES
	decoupler.circuit
	inverting-amplifier.circuit
	noninverting-amplifier.circuit
	instrumentation-amplifier.circuit
	DESTINATION ${DATA_INSTALL_DIR}/ktechlab/examples/opamps)

=== debian/changelog ===
ktechlab (0.50.0-2) unstable; urgency=medium

  * Suggest gputils, picprog, and sdcc, as they can be used by default.
  * Backport upstream commit a24dc9737462662390c9b0f37ce66774283df69c to fix
    lifetime of intermediate temporary files; patch
    upstream_process-chain-keep-temporary-files-live-longer.patch.
  * Backport upstream commit e303b80756770069526ef16e0a81d343c2e9ca13 to fix
    the selection of files as properties; patch
    upstream_Fix-selecting-files-as-properties.patch.
  * Update copyright.
  * Backport upstream commit f3a754ddcbc8a086ca48920bd33e96082cef699c to not
    build a test-only static libraries when testing is disabled; patch
    upstream_cmake-build-test_ktechlab-only-if-testing-is-enabled.patch.
  * Disable the build of testing stuff, as there are no unit tests available:
    - pass -DBUILD_TESTING=OFF to cmake
    - add an empty override for dh_auto_test

 -- Pino Toscano <pino@debian.org>  Mon, 02 Nov 2020 13:27:35 +0100

ktechlab (0.50.0-1) unstable; urgency=medium

  * Re-add back to Debian.

 -- Pino Toscano <pino@debian.org>  Tue, 27 Oct 2020 12:11:07 +0100

=== debian/control ===
Source: ktechlab
Section: kde
Priority: optional
Maintainer: Debian KDE Extras Team <pkg-kde-extras@lists.alioth.debian.org>
Uploaders: Pino Toscano <pino@debian.org>,
Build-Depends: cmake (>= 3.1~),
               debhelper-compat (= 13),
               pkg-kde-tools (>= 0.15.16),
               gettext,
               pkg-config,
               extra-cmake-modules,
               qtbase5-dev,
               libkf5config-dev,
               libkf5coreaddons-dev,
               libkf5doctools-dev,
               libkf5i18n-dev,
               libkf5iconthemes-dev,
               libkf5khtml-dev,
               libkf5kio-dev,
               libkf5parts-dev,
               libkf5solid-dev,
               libkf5texteditor-dev,
               libkf5textwidgets-dev,
               libkf5widgetsaddons-dev,
               libkf5windowsystem-dev,
               libkf5xmlgui-dev,
               libglib2.0-dev,
               gpsim-dev,
Standards-Version: 4.5.0
Rules-Requires-Root: no
Homepage: https://invent.kde.org/sdk/ktechlab
Vcs-Git: https://salsa.debian.org/qt-kde-team/extras/ktechlab.git
Vcs-Browser: https://salsa.debian.org/qt-kde-team/extras/ktechlab

Package: ktechlab
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends}
Suggests: gputils,
          picprog,
          sdcc,
Description: IDE for microcontrollers and electronics
 KTechLab is an IDE for microcontrollers and electronics.
 .
 It supports circuit simulation, program development for microcontrollers and
 simulating the programmed microcontroller together with its application
 circuit.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ --with kf5

override_dh_auto_configure:
	dh_auto_configure -Skf5 -- -DBUILD_TESTING=OFF

override_dh_auto_test:

## ktechlab 0.51.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -5,19 +5,33 @@
 #set( KTECHLAB_DEVELOPER_BUILD "true" )
 
 project( ktechlab )
-set( VERSION 0.50.0 )
+set( VERSION 0.51.0 )
 
 # set(CMAKE_DEBUG_TARGET_PROPERTIES INCLUDE_DIRECTORIES)
 
-find_package(ECM 0.0.11 CONFIG REQUIRED)
+find_package(ECM 5.14.0 CONFIG REQUIRED)
+
+# At least C++14 is required for qOverload MACRO
+set(CMAKE_CXX_STANDARD 14)
+set(CMAKE_CXX_STANDARD_REQUIRED ON)
+
 set(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake/modules ${ECM_MODULE_PATH})
 
 include(KDEInstallDirs)
 include(KDECMakeSettings)
 include(KDECompilerSettings NO_POLICY_SCOPE)
+include(KDEClangFormat OPTIONAL RESULT_VARIABLE KDEClangFormat_FOUND)
+include(ECMSetupVersion)
+include(ECMQtDeclareLoggingCategory)
 
 include(ECMInstallIcons)
 include(FeatureSummary)
+
+ecm_setup_version(
+    "${VERSION}"
+    VARIABLE_PREFIX KTECHLAB
+    VERSION_HEADER ktechlab_version.h
+)
 
 if(BUILD_TESTING)
     set(QT_ADDITIONAL_COMPONENTS Test)
@@ -27,21 +41,22 @@
     DBus
     Widgets
     PrintSupport
+    SerialPort
     ${QT_ADDITIONAL_COMPONENTS}
     )
 
 find_package(KF5 REQUIRED COMPONENTS
+    Completion
     Config
+    ConfigWidgets
     CoreAddons
     DocTools
     IconThemes
     I18n
-    KHtml
     KIO
     Parts
     TextEditor
     TextWidgets
-    Solid
     WidgetsAddons
     WindowSystem
     XmlGui
@@ -53,10 +68,9 @@
 #    macro_pop_required_vars() -> cmake_pop_check_state()
 find_package(GPSim)
 
-add_definitions(-Wno-deprecated-declarations) # TODO too much spam for now
 add_definitions(-fPIC)
 add_definitions(
-    -DQT_DISABLE_DEPRECATED_BEFORE=0 # even 0x050000 would be too high for now
+    -DQT_DISABLE_DEPRECATED_BEFORE=0x050000 # TODO target some reasonable version
     -DQT_DEPRECATED_WARNINGS_SINCE=0x060000 # to enable warnings for API since the disabled limit
 #     -DQT_USE_QSTRINGBUILDER # TODO
 #     -DQT_NO_CAST_TO_ASCII # TODO
@@ -113,7 +127,6 @@
     ${CMAKE_CURRENT_BINARY_DIR}
 )
 
-set( SRC_EXAMPLES_DIR ${CMAKE_CURRENT_SOURCE_DIR}/examples/ )
 set( SRC_TESTS_DATA_DIR ${CMAKE_CURRENT_SOURCE_DIR}/tests/data/ )
 
 CONFIGURE_FILE( ${CMAKE_SOURCE_DIR}/config.h.cmake
@@ -146,10 +159,15 @@
     add_subdirectory(tests)
 endif()
 
+ki18n_install(po)
+
 feature_summary(WHAT ALL FATAL_ON_MISSING_REQUIRED_PACKAGES)
 
-find_package(KF5I18n CONFIG REQUIRED)
-ki18n_install(po)
+# add clang-format target for all our real source files
+if(KDEClangFormat_FOUND)
+    file(GLOB_RECURSE ALL_CLANG_FORMAT_SOURCE_FILES src/*.cpp src/*.h)
+    kde_clang_format(${ALL_CLANG_FORMAT_SOURCE_FILES})
+endif()
 
   find_package(KF5DocTools CONFIG)
   if(KF5DocTools_FOUND)

=== doc/CMakeLists.txt ===
add_subdirectory( en )

=== examples/CMakeLists.txt ===
add_subdirectory(555)
add_subdirectory(basic)
add_subdirectory(diodes)
add_subdirectory(jfets)
add_subdirectory(matrix_disp_driver)
add_subdirectory(mosfets)
add_subdirectory(transistors)
add_subdirectory(opamps)

=== icons/CMakeLists.txt ===
add_subdirectory(pics)

########### install files ###############

file(GLOB icons_apps "${CMAKE_CURRENT_SOURCE_DIR}/*-apps-*.png")
file(GLOB icons_mimetypes "${CMAKE_CURRENT_SOURCE_DIR}/*-mimetypes-*.png")
ecm_install_icons(ICONS ${icons_apps} ${icons_mimetypes} DESTINATION ${KDE_INSTALL_ICONDIR})

=== microbe/CMakeLists.txt ===
--- 
+++ 
@@ -19,7 +19,6 @@
     KF5::I18n
 
     Qt5::Core
+    )
 
-    pthread)
-
-install(TARGETS microbe ${INSTALL_TARGETS_DEFAULT_ARGS})
+install(TARGETS microbe ${KDE_INSTALL_TARGETS_DEFAULT_ARGS})

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -85,14 +85,13 @@
     ./gui/contexthelp.cpp
     ./gui/oscilloscopeview.cpp
     ./gui/doublespinbox.cpp
-    ./gui/lineedit.cpp
     ./gui/inputdialog.cpp
     ./gui/microselectwidget.cpp
     ./gui/scopescreen.cpp
     ./gui/itemselector.cpp
     ./gui/scopescreenview.cpp
     ./gui/microsettingsdlg.cpp
-    ./gui/colorcombo.cpp
+    ./gui/colorutils.cpp
     ./gui/symbolviewer.cpp
     ./gui/oscilloscope.cpp
     ./gui/newfiledlg.cpp
@@ -157,7 +156,6 @@
     ./picitem.cpp
 #     ./core/main.cpp
     ./core/diagnosticstyle.cpp
-    ./core/logtofilemsghandler.cpp
     ./node.cpp
     ./documentiface.cpp
     ./docmanager.cpp
@@ -275,7 +273,6 @@
     ./variablelabel.cpp
     ./item.cpp
     ./itemdocumentdata.cpp
-    ./ktlqt3support/ktlfindqobjectchild.cpp
     ./ktlqt3support/ktlq3scrollview.cpp
     ./ktlqt3support/ktlq3polygonscanner.cpp
     ./ktlqt3support/ktlq3frame.cpp
@@ -300,7 +297,6 @@
     ./flowcodedocument.cpp
     ./libraryitem.cpp
     ./conrouter.cpp
-    ./recentfilesaction.cpp
     ./canvas.cpp
     ./canvasitems.cpp
     ./flowcontainer.cpp
@@ -320,6 +316,13 @@
     ./languages/flowcode.cpp
 )
 
+ecm_qt_declare_logging_category(ktechlab_SRCS
+    HEADER ktechlab_debug.h
+    IDENTIFIER KTL_LOG
+    CATEGORY_NAME org.kde.ktechlab
+    DEFAULT_SEVERITY Warning
+)
+
 set(ktechlab_DCOP_SKEL_SRCS
     docmanageriface.h
     viewiface.h
@@ -341,26 +344,30 @@
     #ktlqt3support
 	#mechanics electronics elements components languages drawparts
 	#itemeditor math
+    KF5::I18n
+    KF5::TextWidgets
     KF5::TextEditor
     KF5::Parts
+    KF5::Completion
     KF5::ConfigCore
     KF5::ConfigGui
+    KF5::ConfigWidgets
     KF5::CoreAddons
     KF5::IconThemes
     KF5::KIOCore
-    KF5::KHtml
     KF5::XmlGui
     KF5::WidgetsAddons
     KF5::WindowSystem
 
     Qt5::Widgets
     Qt5::PrintSupport
+    Qt5::SerialPort
 )
 if(GPSim_FOUND)
     target_link_libraries(ktechlab ${GPSim_LIBRARIES})
 endif()
 
-install(TARGETS ktechlab ${INSTALL_TARGETS_DEFAULT_ARGS})
+install(TARGETS ktechlab ${KDE_INSTALL_TARGETS_DEFAULT_ARGS})
 
 
 # message(STATUS "include_dir begin")
@@ -379,17 +386,8 @@
 
 # for helping testing
 
-add_library(test_ktechlab STATIC ${ktechlab_SRCS})
-
-target_link_libraries(test_ktechlab
-    KF5::TextEditor
-    KF5::IconThemes
-    KF5::Parts
-    KF5::KHtml
-    KF5::WidgetsAddons
-    KF5::WindowSystem
-
-    Qt5::Widgets
-    Qt5::PrintSupport
-)
-
+if(BUILD_TESTING)
+
+    add_library(test_ktechlab STATIC ${ktechlab_SRCS})
+
+    target_link_libraries(test_ktechlab

=== tests/CMakeLists.txt ===
add_subdirectory(loaded-icons)
add_subdirectory(tests_compile)
add_subdirectory(tests_app)

=== examples/555/CMakeLists.txt ===
install(FILES
	internals.circuit
	square-wave.circuit
	DESTINATION ${KDE_INSTALL_DATADIR}/ktechlab/examples/555)

=== examples/basic/CMakeLists.txt ===
install(FILES  
	2-way-switch.circuit
	3-way-switch.circuit
	capacitor.circuit
	lrc.circuit resistors-parallel.circuit
	resistors-series.circuit
	voltage-divider.circuit
	DESTINATION ${KDE_INSTALL_DATADIR}/ktechlab/examples/basic)

=== examples/jfets/CMakeLists.txt ===
install(FILES
	inverter.circuit
	DESTINATION ${KDE_INSTALL_DATADIR}/ktechlab/examples/jfets)

=== examples/matrix_disp_driver/CMakeLists.txt ===
install(FILES
	matrix_display.circuit
	DESTINATION ${KDE_INSTALL_DATADIR}/ktechlab/examples/matrix_disp_driver)

=== examples/mosfets/CMakeLists.txt ===
install(FILES
	and.circuit
	inverter.circuit
	nand.circuit
	nor.circuit
	or.circuit
	DESTINATION ${KDE_INSTALL_DATADIR}/ktechlab/examples/mosfets)

=== debian/changelog ===
ktechlab (0.51.0-3) unstable; urgency=medium

  * Drop Rules-Requires-Root: no, no more needed since Debian trixie.
  * Bump Standards-Version to 4.7.2, no changes required.
  * Pass -DCMAKE_POLICY_VERSION_MINIMUM=3.5 to cmake so it builds with cmake 4
    (hoping that everything works properly). (Closes: #1113089)
  * Switch the transitional pkg-config build dependency to pkgconf.

 -- Pino Toscano <pino@debian.org>  Tue, 07 Oct 2025 07:47:29 +0200

ktechlab (0.51.0-2) unstable; urgency=medium

  * Upload to unstable.
  * Switch Vcs-* fields back to the 'master' packaging branch.

 -- Pino Toscano <pino@debian.org>  Sun, 11 Jun 2023 21:24:05 +0200

ktechlab (0.51.0-1) experimental; urgency=medium

  * New upstream release.
  * Switch Vcs-* fields to the 'experimental' packaging branch.
  * Update lintian override info format in d/ktechlab.lintian-overrides on line
    2.
  * Set upstream metadata fields: Bug-Database, Bug-Submit.
  * Update standards version to 4.6.2, no changes needed.
  * Update the patches:
    - upstream_process-chain-keep-temporary-files-live-longer.patch: drop,
      backported from upstream
    - upstream_Fix-selecting-files-as-properties.patch: drop, backported from
      upstream
    - upstream_cmake-build-test_ktechlab-only-if-testing-is-enabled.patch:
      drop, backported from upstream
  * Update the build dependencies according to the upstream build system:
    - bump extra-cmake-modules to 5.14.0
    - bump gpsim-dev to 0.26
    - add libqt5serialport5-dev, libkf5completion-dev, libkf5configwidgets-dev
    - drop libkf5khtml-dev, and libkf5solid-dev
  * Update copyright.

 -- Pino Toscano <pino@debian.org>  Fri, 31 Mar 2023 08:53:15 +0200

=== debian/control ===
--- 
+++ 
@@ -7,27 +7,27 @@
                debhelper-compat (= 13),
                pkg-kde-tools (>= 0.15.16),
                gettext,
-               pkg-config,
-               extra-cmake-modules,
+               pkgconf,
+               extra-cmake-modules (>= 5.14.0~),
                qtbase5-dev,
+               libqt5serialport5-dev,
+               libkf5completion-dev,
                libkf5config-dev,
+               libkf5configwidgets-dev,
                libkf5coreaddons-dev,
                libkf5doctools-dev,
                libkf5i18n-dev,
                libkf5iconthemes-dev,
-               libkf5khtml-dev,
                libkf5kio-dev,
                libkf5parts-dev,
-               libkf5solid-dev,
                libkf5texteditor-dev,
                libkf5textwidgets-dev,
                libkf5widgetsaddons-dev,
                libkf5windowsystem-dev,
                libkf5xmlgui-dev,
                libglib2.0-dev,
-               gpsim-dev,
-Standards-Version: 4.5.0
-Rules-Requires-Root: no
+               gpsim-dev (>= 0.26~),
+Standards-Version: 4.7.2
 Homepage: https://invent.kde.org/sdk/ktechlab
 Vcs-Git: https://salsa.debian.org/qt-kde-team/extras/ktechlab.git
 Vcs-Browser: https://salsa.debian.org/qt-kde-team/extras/ktechlab

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ --with kf5

override_dh_auto_configure:
	dh_auto_configure -Skf5 -- \
		-DCMAKE_POLICY_VERSION_MINIMUM=3.5 \
		-DBUILD_TESTING=OFF

override_dh_auto_test:

=== debian/watch ===
version=4
https://download.kde.org/unstable/@PACKAGE@/@PACKAGE@-(.*)\.tar\.xz

## ktechlab 0.51.0+p24.04+vstable+git20250914.1637

=== debian/changelog ===
ktechlab (0.51.0+p24.04+vstable+git20250914.1637-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Sun, 14 Sep 2025 16:37:15 +0000

## ktechlab 0.51.0+p24.04+vstable+git20250926.0939

=== debian/changelog ===
ktechlab (0.51.0+p24.04+vstable+git20250926.0939-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Fri, 26 Sep 2025 09:39:20 +0000

## ktechlab 0.51.0+p24.04+vstable+git20251017.0024

=== debian/changelog ===
ktechlab (0.51.0+p24.04+vstable+git20251017.0024-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Fri, 17 Oct 2025 00:24:11 +0000

## ktechlab 0.51.0+p24.04+vstable+git20251019.0628

=== debian/changelog ===
ktechlab (0.51.0+p24.04+vstable+git20251019.0628-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Sun, 19 Oct 2025 06:28:37 +0000

## ktechlab 0.51.0+p24.04+vstable+git20251021.0238

=== debian/changelog ===
ktechlab (0.51.0+p24.04+vstable+git20251021.0238-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Tue, 21 Oct 2025 02:38:59 +0000

=== debian/control ===
Source: ktechlab
Section: kde
Priority: optional
Uploaders: Pino Toscano <pino@debian.org>
Build-Depends: cmake,
               debhelper-compat (= 13),
               gettext,
               gpsim-dev,
               kf6-extra-cmake-modules,
               kf6-kcompletion-dev,
               kf6-kconfig-dev,
               kf6-kconfigwidgets-dev,
               kf6-kcoreaddons-dev,
               kf6-kdoctools-dev,
               kf6-ki18n-dev,
               kf6-kiconthemes-dev,
               kf6-kio-dev,
               kf6-kparts-dev,
               kf6-ktexteditor-dev,
               kf6-ktextwidgets-dev,
               kf6-kwidgetsaddons-dev,
               kf6-kwindowsystem-dev,
               kf6-kxmlgui-dev,
               kf6-syntax-highlighting-dev,
               libglib2.0-dev,
               pkg-kde-tools-neon,
               pkgconf,
               qt6-base-dev,
               qt6-serialport-dev
Standards-Version: 4.6.2
Rules-Requires-Root: no
Homepage: https://invent.kde.org/sdk/ktechlab
Vcs-Git: https://invent.kde.org/neon/extras/ktechlab.git
Vcs-Browser: https://invent.kde.org/neon/extras/ktechlab
Maintainer: Neon CI <neon@kde.org>

Package: ktechlab
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Suggests: gputils, picprog, sdcc
Description: IDE for microcontrollers and electronics
 KTechLab is an IDE for microcontrollers and electronics.
 .
 It supports circuit simulation, program development for microcontrollers and
 simulating the programmed microcontroller together with its application
 circuit.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
%:
	dh $@ --with kf6 --buildsystem kf6

## ktechlab 0.51.0+p24.04+vstable+git20251030.0019

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)

#set( KTECHLAB_DEVELOPER_BUILD "true" )

project( ktechlab )
set( VERSION 0.51.0 )

# set(CMAKE_DEBUG_TARGET_PROPERTIES INCLUDE_DIRECTORIES)

find_package(ECM 6.0.0 CONFIG REQUIRED)

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${ECM_MODULE_PATH} ${CMAKE_CURRENT_SOURCE_DIR}/cmake/modules )

include(KDEInstallDirs)
include(KDECMakeSettings)
include(KDECompilerSettings NO_POLICY_SCOPE)
include(KDEClangFormat OPTIONAL RESULT_VARIABLE KDEClangFormat_FOUND)
include(ECMSetupVersion)
include(ECMQtDeclareLoggingCategory)

include(ECMInstallIcons)
include(FeatureSummary)

ecm_setup_version(
    "${VERSION}"
    VARIABLE_PREFIX KTECHLAB
    VERSION_HEADER ktechlab_version.h
)

if(BUILD_TESTING)
    set(QT_ADDITIONAL_COMPONENTS Test)
endif()

find_package(Qt6 CONFIG REQUIRED COMPONENTS
    Core
    DBus
    Widgets
    PrintSupport
    SerialPort
    Core5Compat
    ${QT_ADDITIONAL_COMPONENTS}
    )

find_package(KF6 REQUIRED COMPONENTS
    Completion
    Config
    ConfigWidgets
    CoreAddons
    DocTools
    IconThemes
    I18n
    KIO
    Parts
    TextEditor
    TextWidgets
    WidgetsAddons
    WindowSystem
    XmlGui
    )

find_package(GPSim)

set(CMAKE_POSITION_INDEPENDENT_CODE ON)
add_definitions(
    -DQT_DISABLE_DEPRECATED_BEFORE=0x060000 # TODO target some reasonable version
    -DQT_DEPRECATED_WARNINGS_SINCE=0x060000 # to enable warnings for API since the disabled limit
    -DQT_USE_QSTRINGBUILDER
    -DQT_NO_CAST_TO_ASCII
#     -DQT_NO_CAST_FROM_ASCII # TODO
     -UQT_NO_CAST_FROM_ASCII # TODO
     -DQT_NO_CAST_FROM_BYTEARRAY
    -DQT_STRICT_ITERATORS
    -DQT_NO_URL_CAST_FROM_STRING
    -DQT_NO_NARROWING_CONVERSIONS_IN_CONNECT
    -DQT_NO_FOREACH
    -DKF_DISABLE_DEPRECATED_BEFORE_AND_AT=0x060000
    -DKF_DEPRECATED_WARNINGS_SINCE=0x060000 # to enable warnings for API since the disabled limit
)

#set(CMAKE_VERBOSE_MAKEFILE ON)

if (KTECHLAB_DEVELOPER_BUILD)
# for debugging with GCC + ASAN
    add_definitions( -fno-omit-frame-pointer )
    set(SANITIZE_FLAGS " -fsanitize=address -fno-omit-frame-pointer -fPIC") # address
    #set(SANITIZE_FLAGS " -fsanitize=undefined -fno-omit-frame-pointer ") # undefined
    #set(SANITIZE_FLAGS "") # disabled

    add_definitions( ${SANITIZE_FLAGS} )
    SET( CMAKE_EXE_LINKER_FLAGS  "${CMAKE_EXE_LINKER_FLAGS} ${SANITIZE_FLAGS}" )

    #add_definitions( -Wold-style-cast ) # warn on old style casts. as these could introduce bugs

endif ()

add_definitions( -fno-inline )  # do not inline any method calls; this is useful for crash debugging

# TODO switch to NO_GPSIM to HAVE_GPSIM
if (NOT GPSim_FOUND)
    set(NO_GPSIM TRUE)
endif ()

if (UNIX AND NOT APPLE)
    set(WITH_X11 TRUE)
endif ()

include_directories(
    # for config.h file
    ${CMAKE_CURRENT_BINARY_DIR}
)

set( SRC_TESTS_DATA_DIR ${CMAKE_CURRENT_SOURCE_DIR}/tests/data/ )

CONFIGURE_FILE( ${CMAKE_SOURCE_DIR}/config.h.cmake
	${CMAKE_BINARY_DIR}/config.h )


# message(STATUS "include_dir begin")
# get_property(dirs DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR} PROPERTY INCLUDE_DIRECTORIES)
# foreach(dir ${dirs})
#   message(STATUS "include_dir='${dir}'")
# endforeach()
# message(STATUS "include_dir end")

# message(STATUS "variables begin")
# get_cmake_property(_variableNames VARIABLES)
# list (SORT _variableNames)
# foreach (_variableName ${_variableNames})
#     message(STATUS "${_variableName}=${${_variableName}}")
# endforeach()
# message(STATUS "variables end")

add_subdirectory( microbe )
add_subdirectory( src )
add_subdirectory( examples )
add_subdirectory( icons )
add_subdirectory( icons-kde3 )
add_subdirectory( doc )

if(BUILD_TESTING)
    add_subdirectory(tests)
endif()

ki18n_install(po)

feature_summary(WHAT ALL FATAL_ON_MISSING_REQUIRED_PACKAGES)

# add clang-format target for all our real source files
if(KDEClangFormat_FOUND)
    file(GLOB_RECURSE ALL_CLANG_FORMAT_SOURCE_FILES src/*.cpp src/*.h)
    kde_clang_format(${ALL_CLANG_FORMAT_SOURCE_FILES})
endif()

=== src/core/CMakeLists.txt ===
SET(core_STAT_SRCS
#    diagnosticstyle.cpp
#    main.cpp
)

set(core_KCFG_SRCS
    ktlconfig.kcfgc
)

kconfig_add_kcfg_files(core_STAT_SRCS ${core_KCFG_SRCS})

add_library(core STATIC ${core_STAT_SRCS})
target_link_libraries(core
    KF6::ConfigGui
    Qt6::Core5Compat
)

########### install files ###############

install(FILES ktechlab.kcfg DESTINATION ${KDE_INSTALL_KCFGDIR})

=== tests/loaded-icons/CMakeLists.txt ===

add_executable(test_loaded_icons test-loaded-icons.cpp)

target_link_libraries( test_loaded_icons
    KF6::CoreAddons
    KF6::I18n
    KF6::IconThemes
    Qt6::Widgets
)

## ktechlab 0.51.0+p24.04+vstable+git20260119.0110

=== debian/changelog ===
ktechlab (0.51.0+p24.04+vstable+git20260119.0110-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Mon, 19 Jan 2026 01:10:50 +0000

## ktechlab 0.51.0+p24.04+vstable+git20260122.0507

=== debian/changelog ===
ktechlab (0.51.0+p24.04+vstable+git20260122.0507-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Thu, 22 Jan 2026 05:07:51 +0000

## ktechlab 0.51.0+p24.04+vstable+git20260130.1115

=== debian/changelog ===
ktechlab (0.51.0+p24.04+vstable+git20260130.1115-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Fri, 30 Jan 2026 11:15:48 +0000

## ktechlab 0.51.0+p24.04+vunstable+git20250926.0758

=== debian/changelog ===
ktechlab (0.51.0+p24.04+vunstable+git20250926.0758-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Fri, 26 Sep 2025 07:58:26 +0000

## ktechlab 0.51.0+p24.04+vunstable+git20251016.0025

=== debian/changelog ===
ktechlab (0.51.0+p24.04+vunstable+git20251016.0025-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Thu, 16 Oct 2025 00:25:20 +0000

## ktechlab 0.51.0+p24.04+vunstable+git20251021.0239

=== debian/changelog ===
ktechlab (0.51.0+p24.04+vunstable+git20251021.0239-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Tue, 21 Oct 2025 02:40:01 +0000

## ktechlab 0.51.0+p24.04+vunstable+git20251113.0758

=== debian/changelog ===
ktechlab (0.51.0+p24.04+vunstable+git20251113.0758-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Thu, 13 Nov 2025 07:58:09 +0000

## ktechlab 0.51.0+p24.04+vunstable+git20251123.1234

=== debian/changelog ===
ktechlab (0.51.0+p24.04+vunstable+git20251123.1234-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Sun, 23 Nov 2025 12:34:46 +0000

## ktechlab 0.51.0+p24.04+vunstable+git20260104.0329

=== debian/changelog ===
ktechlab (0.51.0+p24.04+vunstable+git20260104.0329-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Sun, 04 Jan 2026 03:29:48 +0000

## ktechlab 0.51.0+p24.04+vunstable+git20260130.0742

=== debian/changelog ===
ktechlab (0.51.0+p24.04+vunstable+git20260130.0742-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Fri, 30 Jan 2026 07:42:41 +0000

## ktechlab 0.51.0+p24.04+vunstable+git20260201.0819

=== debian/changelog ===
ktechlab (0.51.0+p24.04+vunstable+git20260201.0819-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Sun, 01 Feb 2026 08:19:52 +0000
